<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/View.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/View.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/View.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string">View base class, contains base functionality and common interface for all Views.</span></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parametrized, Parameter</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> open_file</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Tags <span class="py-keyword">import</span> *</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">import</span> re, os</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Format.html">Format</a>(Parametrized):</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Default and base class for formatting a view layout. The Format</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-string">    class basically defines the HTML used at the start and end of the view.</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-string">    The default creates an XHTML compliant header and footer with a proper</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-string">    title, and link to the stylesheet.&quot;&quot;&quot;</span></span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Format.html#init">init</a>(self, processor, prefix):</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        self.prefix = prefix</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Format.html#view_header">view_header</a>(self, os, title, body, headextra, view):</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Called to output the view header to the given output stream.</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-string">        @param os a file-like object (use os.write())</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">        @param title the title of this view</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-string">        @param body the body tag, which may contain extra parameters such as</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-string">        onLoad scripts, and may also be empty eg: for the frames index</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">        @param headextra extra html to put in the head section, such as</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">        scripts</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        os.write(<span class="py-string">'&lt;?xml version=&quot;1.0&quot; encoding=&quot;iso-8859-1&quot;?&gt;\n'</span>)</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        os.write(<span class="py-string">'&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot;\n'</span>)</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        os.write(<span class="py-string">'    &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt;\n'</span>)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        os.write(<span class="py-string">'&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot; lang=&quot;en&quot;&gt;\n'</span>)</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        os.write(<span class="py-string">'&lt;!-- '</span> + view.filename() + <span class="py-string">' --&gt;\n'</span>)</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">        os.write(<span class="py-string">'&lt;!-- this view was generated by '</span> + view.__class__.__name__ + <span class="py-string">' --&gt;\n'</span>)</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        os.write(<span class="py-string">&quot;&lt;head&gt;\n&quot;</span>)</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        os.write(<span class="py-string">'&lt;meta content=&quot;text/html; charset=iso-8859-1&quot; http-equiv=&quot;Content-Type&quot;/&gt;\n'</span>)</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        os.write(element(<span class="py-string">'title'</span>,<span class="py-string">'Synopsis - '</span>+ title) + <span class="py-string">'\n'</span>)</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        css = self.prefix + <span class="py-string">'style.css'</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        os.write(element(<span class="py-string">'link'</span>, type=<span class="py-string">'text/css'</span>, rel=<span class="py-string">'stylesheet'</span>, href=css) + <span class="py-string">'\n'</span>)</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        os.write(headextra)</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        os.write(<span class="py-string">&quot;&lt;/head&gt;\n%s\n&quot;</span>%body)</span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Format.html#view_footer">view_footer</a>(self, os, body):</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Called to output the view footer to the given output stream.</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-string">        @param os a file-like object (use os.write())</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="py-string">        @param body the close body tag, which may be empty eg: for the frames</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="py-string">        index</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        os.write(<span class="py-string">&quot;\n%s\n&lt;/html&gt;\n&quot;</span>%body)</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html">Template</a>(Format):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Format subclass that uses a template file to define the HTML header</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="py-string">    and footer for each view.&quot;&quot;&quot;</span></span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    template = Parameter(<span class="py-string">''</span>, <span class="py-string">'the html template file'</span>)</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">    copy_files = Parameter([], <span class="py-string">'a list of files to be copied into the output dir'</span>)</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html#init">init</a>(self, processor, prefix):</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        Format.init(self, processor, prefix)</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">        self.__re_body = re.compile(<span class="py-string">'&lt;body(?P&lt;params&gt;([ \t\n]+[-a-zA-Z0-9]+=(&quot;[^&quot;]*&quot;|\'[^\']*\'|[^ \t\n&gt;]*))*)&gt;'</span>, re.I)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        self.__re_closebody = re.compile(<span class="py-string">'&lt;/body&gt;'</span>, re.I)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        self.__re_closehead = re.compile(<span class="py-string">'&lt;/head&gt;'</span>, re.I)</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        self.__title_tag = <span class="py-string">'@TITLE@'</span></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        self.__content_tag = <span class="py-string">'@CONTENT@'</span></span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        <span class="py-keyword">for</span> file <span class="py-keyword">in</span> self.copy_files:</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">            processor.file_layout.copy_file(file, file)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        self.load_file()</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html#load_file">load_file</a>(self):</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Loads and parses the template file&quot;&quot;&quot;</span></span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        f = open(self.template, <span class="py-string">'rt'</span>)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        text = f.read(1024*64) <span class="py-comment"># arbitrary max limit of 64kb</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        f.close()</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-comment"># Find the content tag</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        content_index = text.find(self.__content_tag)</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-keyword">if</span> content_index == -1:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;Fatal: content tag '%s' not found in template file!&quot;</span>%self.__content_tag</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            <span class="py-keyword">raise</span> SystemError, <span class="py-string">&quot;Content tag not found&quot;</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        header = text[:content_index]</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        <span class="py-comment"># Find the title (doesn't matter if not found)</span></span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        self.__title_index = text.find(self.__title_tag)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        <span class="py-keyword">if</span> self.__title_index != -1:</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">            <span class="py-comment"># Remove the title tag</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">            header = header[:self.__title_index] +header[self.__title_index+len(self.__title_tag):]</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-comment"># Find the close head tag</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        mo = self.__re_closehead.search(header)</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        <span class="py-keyword">if</span> mo: self.__headextra_index = mo.start()</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">else</span>: self.__headextra_index = -1</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        <span class="py-comment"># Find the body tag</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        mo = self.__re_body.search(header)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> mo:</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;Fatal: body tag not found in template file!&quot;</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;(if you are sure there is one, this may be a bug in Synopsis)&quot;</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            <span class="py-keyword">raise</span> SystemError, <span class="py-string">&quot;Body tag not found&quot;</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-keyword">if</span> mo.group(<span class="py-string">'params'</span>): self.__body_params = mo.group(<span class="py-string">'params'</span>)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        <span class="py-keyword">else</span>: self.__body_params = <span class="py-string">''</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        self.__body_index = mo.start()</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        header = header[:mo.start()] + header[mo.end():]</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        <span class="py-comment"># Store the header</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        self.__header = header</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        footer = text[content_index+len(self.__content_tag):]</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-comment"># Find the close body tag</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        mo = self.__re_closebody.search(footer)</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> mo:</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;Fatal: close body tag not found in template file&quot;</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">            <span class="py-keyword">raise</span> SystemError, <span class="py-string">&quot;Close body tag not found&quot;</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        self.__closebody_index = mo.start()</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        footer = footer[:mo.start()] + footer[mo.end():]</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        self.__footer = footer</span>
<a id="line123"></a><span class="lineno">123</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html#write">write</a>(self, os, text):</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Writes the text to the output stream, replaceing @PREFIX@ with the</span></span>
<a id="line126"></a><span class="lineno">126</span><span class="line"><span class="py-string">        prefix for this file&quot;&quot;&quot;</span></span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        sections = text.split(<span class="py-string">'@PREFIX@'</span>)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        os.write(self.prefix.join(sections))</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html#view_header">view_header</a>(self, os, title, body, headextra, view):</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the header using the template file&quot;&quot;&quot;</span></span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> body: <span class="py-keyword">return</span> Format.view_header(self, os, title, body, headextra)</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        header = self.__header</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        index = 0</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        <span class="py-keyword">if</span> self.__title_index != -1:</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">            self.write(os, header[:self.__title_index])</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">            self.write(os, title)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">            index = self.__title_index</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        <span class="py-keyword">if</span> self.__headextra_index != -1:</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            self.write(os, header[index:self.__headextra_index])</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            self.write(os, headextra)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">            index = self.__headextra_index</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        self.write(os, header[index:self.__body_index])</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-keyword">if</span> body:</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">            <span class="py-keyword">if</span> body[-1] == <span class="py-string">'&gt;'</span>:</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">                self.write(os, body[:-1]+self.__body_params+body[-1])</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">                <span class="py-comment"># Hmmmm... Should not happen, perhaps use regex?</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line">                self.write(os, body)</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        self.write(os, header[self.__body_index:])</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/Template.html#view_footer">view_footer</a>(self, os, body):</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the footer using the template file&quot;&quot;&quot;</span></span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> body: <span class="py-keyword">return</span> Format.view_footer(self, os, body)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        footer = self.__footer</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        self.write(os, footer[:self.__closebody_index])</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        self.write(os, body)</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        self.write(os, footer[self.__closebody_index:])</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html">View</a>(Parametrized):</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Base class for Views. The base class provides a common interface, and</span></span>
<a id="line165"></a><span class="lineno">165</span><span class="line"><span class="py-string">    also handles common operations such as opening the file, and delegating</span></span>
<a id="line166"></a><span class="lineno">166</span><span class="line"><span class="py-string">    the view formatting to a strategy class.&quot;&quot;&quot;</span></span>
<a id="line167"></a><span class="lineno">167</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    template = Parameter(Format(), <span class="py-string">'the object that provides the html template for the view'</span>)</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        super(View, self).__init__(**kwds)</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">        self.main = False</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#register">register</a>(self, frame):</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Registers this View class with its frame.&quot;&quot;&quot;</span></span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        self.frame = frame</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        self.directory_layout = self.frame.processor.directory_layout</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        self.processor = frame.processor</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        self.__os = None</span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#filename">filename</a>(self):</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the filename (currently) associated with the view.&quot;&quot;&quot;</span></span>
<a id="line185"></a><span class="lineno">185</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#title">title</a>(self):</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the title (currently) associated with the view.&quot;&quot;&quot;</span></span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#root">root</a>(self):</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return a pair of (url, label) to link to the entry point of this view.&quot;&quot;&quot;</span></span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        <span class="py-keyword">return</span> None, None</span>
<a id="line197"></a><span class="lineno">197</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#write_navigation_bar">write_navigation_bar</a>(self):</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generate a navigation bar for this view.&quot;&quot;&quot;</span></span>
<a id="line200"></a><span class="lineno">200</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">        self.write(self.frame.navigation_bar(self) + <span class="py-string">'\n'</span>)</span>
<a id="line202"></a><span class="lineno">202</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#os">os</a>(self):</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">        <span class="py-string">&quot;Returns the output stream opened with start_file&quot;</span></span>
<a id="line205"></a><span class="lineno">205</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        <span class="py-keyword">return</span> self.__os</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#write">write</a>(self, str):</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Writes the given string to the currently opened file&quot;&quot;&quot;</span></span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        self.__os.write(str)</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#register_filenames">register_filenames</a>(self):</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Register filenames for each file this View will generate.&quot;&quot;&quot;</span></span>
<a id="line215"></a><span class="lineno">215</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line217"></a><span class="lineno">217</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#toc">toc</a>(self):</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Retrieves the TOC for this view. This method assumes that the view</span></span>
<a id="line220"></a><span class="lineno">220</span><span class="line"><span class="py-string">        generates info for the the whole ASG, which could be the Scope,</span></span>
<a id="line221"></a><span class="lineno">221</span><span class="line"><span class="py-string">        the Source (source code) or the XRef (cross reference info).</span></span>
<a id="line222"></a><span class="lineno">222</span><span class="line"><span class="py-string">        The default implementation returns None.&quot;&quot;&quot;</span></span>
<a id="line223"></a><span class="lineno">223</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#process">process</a>(self):</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Process the ASG, creating view-specific html pages.&quot;&quot;&quot;</span></span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#open_file">open_file</a>(self):</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a new output stream. This template method is for internal</span></span>
<a id="line233"></a><span class="lineno">233</span><span class="line"><span class="py-string">        use only, but may be overriden in derived classes.</span></span>
<a id="line234"></a><span class="lineno">234</span><span class="line"><span class="py-string">        The default joins output dir and self.filename()&quot;&quot;&quot;</span></span>
<a id="line235"></a><span class="lineno">235</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">        path = os.path.join(self.processor.output, self.filename())</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">        <span class="py-keyword">return</span> open_file(path)</span>
<a id="line238"></a><span class="lineno">238</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#close_file">close_file</a>(self):</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Closes the internal output stream. This template method is for</span></span>
<a id="line241"></a><span class="lineno">241</span><span class="line"><span class="py-string">        internal use only, but may be overriden in derived classes.&quot;&quot;&quot;</span></span>
<a id="line242"></a><span class="lineno">242</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">        self.__os.close()</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">        self.__os = None</span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#start_file">start_file</a>(self, body=<span class="py-string">''</span>, headextra=<span class="py-string">''</span>):</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Start a new file with given filename, title and body. This method</span></span>
<a id="line248"></a><span class="lineno">248</span><span class="line"><span class="py-string">        opens a file for writing, and writes the html header crap at the top.</span></span>
<a id="line249"></a><span class="lineno">249</span><span class="line"><span class="py-string">        You must specify a title, which is prepended with the project name.</span></span>
<a id="line250"></a><span class="lineno">250</span><span class="line"><span class="py-string">        The body argument is optional, and it is preferred to use stylesheets</span></span>
<a id="line251"></a><span class="lineno">251</span><span class="line"><span class="py-string">        for that sort of stuff. You may want to put an onLoad handler in it</span></span>
<a id="line252"></a><span class="lineno">252</span><span class="line"><span class="py-string">        though in which case that's the place to do it. The opened file is</span></span>
<a id="line253"></a><span class="lineno">253</span><span class="line"><span class="py-string">        stored and can be accessed using the os() method.&quot;&quot;&quot;</span></span>
<a id="line254"></a><span class="lineno">254</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">        self.__os = self.open_file()</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">        prefix = rel(self.filename(), <span class="py-string">''</span>)</span>
<a id="line257"></a><span class="lineno">257</span><span class="line">        self.template.init(self.processor, prefix)</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> body:</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">            body = <span class="py-string">'&lt;body class=&quot;%s&quot;&gt;'</span>%self.__class__.__name__</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">        self.template.view_header(self.__os, self.title(), body, headextra, self)</span>
<a id="line261"></a><span class="lineno">261</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#end_file">end_file</a>(self, body=<span class="py-string">'&lt;/body&gt;'</span>):</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Close the file using given close body tag. The default is</span></span>
<a id="line264"></a><span class="lineno">264</span><span class="line"><span class="py-string">        just a close body tag, but if you specify '' then nothing will be</span></span>
<a id="line265"></a><span class="lineno">265</span><span class="line"><span class="py-string">        written (useful for a frames view)&quot;&quot;&quot;</span></span>
<a id="line266"></a><span class="lineno">266</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">        self.template.view_footer(self.__os, body)</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">        self.close_file()</span>
<a id="line269"></a><span class="lineno">269</span>
<a id="line270"></a><span class="lineno">270</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/View/View.html#reference">reference</a>(self, name, scope, label=None, **keys):</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a reference to the given name. The name is a scoped name,</span></span>
<a id="line272"></a><span class="lineno">272</span><span class="line"><span class="py-string">        and the optional label is an alternative name to use as the link text.</span></span>
<a id="line273"></a><span class="lineno">273</span><span class="line"><span class="py-string">        The name is looked up in the TOC so the link may not be local. The</span></span>
<a id="line274"></a><span class="lineno">274</span><span class="line"><span class="py-string">        optional keys are appended as attributes to the A tag.&quot;&quot;&quot;</span></span>
<a id="line275"></a><span class="lineno">275</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> label: label = escape(str(scope.prune(name)))</span>
<a id="line277"></a><span class="lineno">277</span><span class="line">        entry = self.processor.toc[name]</span>
<a id="line278"></a><span class="lineno">278</span><span class="line">        <span class="py-keyword">if</span> entry: <span class="py-keyword">return</span> href(rel(self.filename(), entry.link), label, **keys)</span>
<a id="line279"></a><span class="lineno">279</span><span class="line">        <span class="py-keyword">return</span> label <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line280"></a><span class="lineno">280</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
